diff --git a/doc/README.scrapyard b/doc/README.scrapyard
index 365c17b..5da8611 100644
--- a/doc/README.scrapyard
+++ b/doc/README.scrapyard
@@ -41,6 +41,7 @@ atstk1004        avr32       -              e5354b8a    2015-06-10  Haavard Skin
 atstk1006        avr32       -              e5354b8a    2015-06-10  Haavard Skinnemoen <haavard.skinnemoen@atmel.com>
 B2               arm         s3c44b0        5dcf536     2011-07-16  Andrea Scian <andrea.scian@dave-tech.it>
 BAB7xx           powerpc     MPC740/MPC750  c53043b     2011-12-07  Frank Gottschling <fgottschling@eltec.de>
+balloon3         arm         pxa            -           -
 barco            powerpc     MPC8245        afaa27b     2010-11-23  Marc Leeman <marc.leeman@barco.com>
 BC3450           powerpc     mpc5xxx        f8296d69    2015-03-17
 bluestone        powerpc     ppc4xx         9ed3246	2014-10-10  Tirumala Marri <tmarri@apm.com>
@@ -68,32 +69,57 @@ CPCI750		 powerpc     74xx_7xx	    03b0040	2014-10-27  Reinhard Arlt <reinhard.a
 CPCIISER4        ppc4xx      405gp          37057260    2015-01-13  Matthias Fuchs <matthias.fuchs@esd.eu>
 CPU86            powerpc     mpc8260        f7e1af86    2015-01-05  Wolfgang Denk <wd@denx.de>
 CPU87            powerpc     mpc8260        f7e1af86    2015-01-05
+cpu9260_128M     arm         arm926ejs      -           -
+cpu9260          arm         arm926ejs      -           -
+cpu9260_nand_128M arm         arm926ejs      -           -
+cpu9260_nand     arm         arm926ejs      -           -
+cpu9G20_128M     arm         arm926ejs      -           -
+cpu9G20          arm         arm926ejs      -           -
+cpuat91          arm         arm920t        -           -
+cpuat91_ram      arm         arm920t        -           -
 cradle           arm         pxa            00c4aca     2011-11-25  Kyle Harris <kharris@nexus-tech.net>
 CRAYL1           powerpc     ppc4xx         1521cdc	2014-10-10  David Updegraff <dave@cray.com>
 csb272/csb472    powerpc     ppc4xx         -           -           Tolunay Orkun <torkun@nextio.com>
 csb637           arm         arm920t        d14af08     2011-07-17
 CU824            powerpc     mpc824x        d622ac39    2015-01-05  Wolfgang Denk <wd@denx.de>
+d2net_v2         arm         arm926ejs      -           -
+da830evm         arm         arm926ejs      -           -
 DASA_SIM         powerpc     ppc4xx         99bcad1     2012-09-19  Matthias Fuchs <matthias.fuchs@esd-electronics.com>
+davinci_dm355evm arm         arm926ejs      -           -
+davinci_dm355leopard arm         arm926ejs      -           -
+davinci_dm365evm arm         arm926ejs      -           -
+davinci_dm6467evm arm         arm926ejs      -           -
+davinci_dm6467Tevm arm         arm926ejs      -           -
+davinci_dvevm    arm         arm926ejs      -           -
+davinci_schmoogie arm         arm926ejs      -           -
+davinci_sffsdr   arm         arm926ejs      -           -
+davinci_sonata   arm         arm926ejs      -           -
 DB64360		 powerpc     74xx_7xx	    03b0040	2014-10-27
 DB64460		 powerpc     74xx_7xx	    03b0040	2014-10-27
 debris           powerpc     mpc824x        7edb1f7b    2014-05-30  Sangmoon Kim <dogoil@etinsys.com>
 delta            ARM         PXA2xx         75e2035     2010-10-20
+dig297           arm         armv7          -           -
 dkb              arm         arm926ejs      346cfba4    2015-02-24  Lei Wen <leiwen@marvell.com>
 dnp1110          arm         sa1100         fc5e5ce     2011-09-05  Alex Züpke <azu@sysgo.de>
 DP405            ppc4xx      405ep          9a4018e0    2015-01-13  Matthias Fuchs <matthias.fuchs@esd.eu>
 DU405            ppc4xx      405gpr         bc114076    2015-01-13  Matthias Fuchs <matthias.fuchs@esd.eu>
 DU440            ppc4xx      440epx         7ac9d47a    2015-01-13  Matthias Fuchs <matthias.fuchs@esd.eu>
 dvl_host         arm         ixp            e317de6b    2014-01-28  Michael Schwingen <michael@schwingen.org>
+ea20             arm         arm926ejs      -           -
+eb_cpux9k2       arm         arm920t        -           -
+eb_cpux9k2_ram   arm         arm920t        -           -
 edb9301          arm         arm920t        716f7ad     2011-07-17
 edb9302a         arm         arm920t        716f7ad     2011-07-17
 edb9302          arm         arm920t        716f7ad     2011-07-17
 edb9307a         arm         arm920t        716f7ad     2011-07-17
 edb9307          arm         arm920t        716f7ad     2011-07-17
 edb9312          arm         arm920t        716f7ad     2011-07-17
+edb9315a         arm         arm920t        -           -
 edb9315a         arm         arm920t        716f7ad     2011-07-17
 edb9315          arm         arm920t        716f7ad     2011-07-17
 ELPPC            powerpc     74xx_7xx       d928664f    2015-01-16
 ELPT860          powerpc     mpc8xx         3c5b20f1    2015-01-05  The LEOX team <team@leox.org>
+enbw_cmc         arm         arm926ejs      -           -
 eNET             x86         x86            7e8c53d     2013-02-14  Graeme Russ <graeme.russ@gmail.com>
 ep7312           arm         arm720t        c8f63b4     2011-09-05  Marius Gröger <mag@sysgo.de>
 ep8248           powerpc     mpc8260        49ad566d    2014-05-30  Yuli Barcohen <yuli@arabellasw.com>
@@ -134,8 +160,12 @@ icecube_5200     powerpc     mpc5xxx        37b608a5    2015-01-23  Wolfgang Den
 ICU862           powerpc     mpc8xx         4af5f0f     2014-10-27  Wolfgang Denk <wd@denx.de>
 idmr             m68k        mcf52x2        ba650e9b    2014-01-28
 IDS8247          powerpc     mpc8260        6afb357     2014-10-27  Heiko Schocher <hs@denx.de>
+ima3-mx53        arm         armv7          -           -
 impa7            arm         arm720t        c1f8750     2011-09-05  Marius Gröger <mag@sysgo.de>
+imx27lite        arm         arm926ejs      -           -
+imx31_litekit    arm         arm1136        -           -
 incaip           mips        mips32         538cf92c    2014-04-20  Wolfgang Denk <wd@denx.de>
+inetspace_v2     arm         arm926ejs      -           -
 IP860            powerpc     mpc8xx         5ec71100    2015-01-05  Wolfgang Denk <wd@denx.de>
 IPHASE4539       powerpc     mpc8260        87882f57    2015-01-05  Wolfgang Grandegger <wg@denx.de>
 ispan            powerpc     mpc8260        80bae39a    2014-05-30  Yuli Barcohen <yuli@arabellasw.com>
@@ -144,6 +174,7 @@ IVMS8            powerpc     mpc8xx         ca620cd1    2015-01-05  Wolfgang Den
 ixdp425          arm         ixp            0ca8eb7     2011-09-22  Kyle Harris <kharris@nexus-tech.net>
 ixdpg425         arm         ixp            0ca8eb7     2011-09-22  Stefan Roese <sr@denx.de>
 jadecpu          arm         arm926ejs      41fbbbbc    2015-02-24  Matthias Weisser <weisserm@arcor.de>
+jornada          arm         sa1100         -           -
 JSE              powerpc     ppc4xx         2da8137b    2015-03-17  Stephen Williams <steve@icarus.com>
 KAREF            powerpc     ppc4xx         dc9617e	2014-10-10  Travis Sawyer <travis.sawyer@sandburst.com>
 kb9202           arm         arm920t        5bd3814     2011-07-17
@@ -155,6 +186,7 @@ LANTEC           powerpc     mpc850         1b0757e     2012-10-28  Wolfgang Den
 lart             arm         sa1100         3d57573     2011-09-05  Alex Züpke <azu@sysgo.de>
 Lite5200         powerpc     mpc5xxx        37b608a5    2015-01-23
 logodl           ARM         PXA2xx         059e778     2010-10-18  August Hoeraendl <august.hoerandl@gmx.at>
+lp8x4x           arm         pxa            -           -
 lpc2292sodimm    arm         arm720t        d1a067a     2011-09-05
 lpd7a404         arm         lh7a40x        957731e     2011-07-17
 lubbock          arm         pxa            36bf57b     2014-04-18  Kyle Harris <kharris@nexus-tech.net>
@@ -162,6 +194,7 @@ lwmon5           powerpc     ppc4xx         -           -           Stefan Roese
 lwmon            powerpc     mpc8xx         acc2372d    2015-01-05  Wolfgang Denk <wd@denx.de>
 m501sk           arm         arm920t        b1a2bd4     2011-07-17
 M5271EVB         m68k        mcf52x2        ba650e9b    2014-01-28
+magnesium        arm         arm926ejs      -           -
 mbx8xx           powerpc     mpc8xx         d6b11fd     2014-04-18
 MCC200		 powerpc     mpc5200	    ecfdcee     2014-11-12
 mecp5200         powerpc     mpc5xxx        37b608a5    2015-01-23  Reinhard Arlt <reinhard.arlt@esd-electronics.com>
@@ -182,6 +215,7 @@ mpq101           powerpc     mpc85xx        e877fab     2011-10-23  Alex Dubov <
 muas3001         powerpc     mpc8260        d2fd1d66    2015-01-05  Heiko Schocher <hs@denx.de>
 mucmc52          powerpc     mpc5xxx        ceaf499b    2015-01-05  Heiko Schocher <hs@denx.de>
 MUSENKI          powerpc     mpc824x        d622ac39    2015-01-05  Jim Thompson <jim@musenki.com>
+mv88f6281gtw_ge  arm         arm926ejs      -           -
 MVBC_P           powerpc     mpc5xxx        af55e35	2014-10-10  Andre Schwarz <andre.schwarz@matrix-vision.de>
 MVBLM7           powerpc     mpc83xx        e7a5656	2014-10-10  Andre Schwarz <andre.schwarz@matrix-vision.de>
 MVBLUE           powerpc     mpc824x        d622ac39    2015-01-05
@@ -189,12 +223,16 @@ MVS1             powerpc     MPC823         306620b     2008-08-26  Andre Schwar
 MVSMR            powerpc     mpc5xxx        af55e35	2014-10-10  Andre Schwarz <andre.schwarz@matrix-vision.de>
 mx1ads           arm         arm920t        e570aca9    2014-01-13
 mx1fs2           arm         arm920t        6962419     2011-07-17
+mx51_efikamx     arm         armv7          -           -
+mx51_efikasb     arm         armv7          -           -
 NC650            powerpc     MPC852         333d86d     2010-10-19  Wolfgang Denk <wd@denx.de>
 netphone         powerpc     mpc8xx         c51c1c9a    2014-07-07
 netstar          arm         arm925t        6ea2405     2011-07-17
 netta2           powerpc     mpc8xx         c51c1c9a    2014-07-07
 netta            powerpc     mpc8xx         c51c1c9a    2014-07-07
 NETVIA           powerpc     mpc8xx         f017cd7f    2015-01-05  Pantelis Antoniou <panto@intracom.gr>
+nhk8815          arm         arm926ejs      -           -
+nhk8815_onenand  arm         arm926ejs      -           -
 ns9750dev        arm         arm926ejs      4cfc611     2013-02-28  Markus Pietrek <mpietrek@fsforth.de>
 NSCU             powerpc     mpc8xx         5d2a5ef7    2015-01-05
 nx823            powerpc     mpc8xx         a146e8b     2014-04-18
@@ -203,6 +241,11 @@ omap1510inn      arm         arm925t        0610a16     2013-09-23  Kshitij Gupt
 omap2420h4       arm         omap24xx       7f5eef9     2013-06-04  Richard Woodruff <r-woodruff2@ti.com>
 omap5912osk      arm         arm926ejs      62d636aa    2014-08-22  Rishi Bhattacharya <rishi@ti.com>
 omap730p2        arm         arm926ejs      79c5c08d    2013-11-11
+openrd_base      arm         arm926ejs      -           -
+openrd_client    arm         arm926ejs      -           -
+openrd_ultimate  arm         arm926ejs      -           -
+otc570           arm         arm926ejs      -           -
+otc570_dataflash arm         arm926ejs      -           -
 OXC              powerpc     MPC8240        309a292     2011-12-07
 P1011RDB         powerpc     mpc85xx        743d4815    2015-01-23
 P1020RDB         powerpc     mpc85xx        743d4815    2015-01-23
@@ -215,6 +258,9 @@ P3G4             powerpc     74xx_7xx       d928664f    2015-01-16  Wolfgang Den
 p3m7448		 powerpc     74xx_7xx	    03b0040	2014-10-27  Stefan Roese <sr@denx.de>
 p3m750		 powerpc     74xx_7xx	    03b0040	2014-10-27  Stefan Roese <sr@denx.de>
 p3p440           powerpc     ppc4xx         -           -           Stefan Roese <sr@denx.de>
+palmld           arm         pxa            -           -
+palmtc           arm         pxa            -           -
+palmtreo680      arm         pxa            -           -
 PCI405           ppc4xx      405gp          dbe7bb0d    2015-01-13  Matthias Fuchs <matthias.fuchs@esd.eu>
 PCI5441          nios2       -              70fbc461    2014-08-24  Scott McNutt <smcnutt@psyent.com>
 PCIPPC2          powerpc     MPC740/MPC750  7c9e89b     2013-02-07  Wolfgang Denk <wd@denx.de>
@@ -231,10 +277,14 @@ PM826            powerpc     mpc8260        dc0b2fb4    2015-01-05  Wolfgang Den
 PM828            powerpc     mpc8260        dc0b2fb4    2015-01-05
 PMC405           ppc4xx      405gp          d5263304    2015-01-13  Matthias Fuchs <matthias.fuchs@esd.eu>
 pn62             powerpc     mpc824x        649acfe1    2013-11-11  Wolfgang Grandegger <wg@grandegger.com>
+polaris          arm         pxa            -           -
+portuxg20        arm         arm926ejs      -           -
 PPChameleonEVB   powerpc     ppc4xx         5344cc1a    2015-01-23  Andrea "llandre" Marson <andrea.marson@dave-tech.it>
 ppmc7xx          powerpc     74xx_7xx       d928664f    2015-01-16
 ppmc8260         powerpc     mpc8260        793116d2    2015-01-05  Brad Kemp <Brad.Kemp@seranoa.com>
 PRS200		 powerpc     mpc5200	    ecfdcee	2014-11-12
+pxa255_idp       arm         pxa            -           -
+qong             arm         arm1136        -           -
 qs850            powerpc     mpc8xx         dab0f762    2014-07-07
 qs860t           powerpc     mpc8xx         dab0f762    2014-07-07
 quad100hd        powerpc     ppc405ep       3569571d    2014-05-30  Gary Jennejohn <gljennjohn@googlemail.com>
@@ -243,6 +293,7 @@ R360MPI          powerpc     mpc8xx         79cbecb8    2015-01-05  Wolfgang Den
 R5200            ColdFire    -              48ead7a     2008-03-31  Zachary P. Landau <zachary.landau@labxtechnologies.com>
 rattler          powerpc     mpc8260        d0664db4    2014-05-30  Yuli Barcohen <yuli@arabellasw.com>
 rbc823           powerpc     mpc8xx         c750b9c0    2014-07-07
+rd6281a          arm         arm926ejs      -           -
 rmu              powerpc     MPC850         fb82fd7     2011-12-07  Wolfgang Denk <wd@denx.de>
 RPXClassic       powerpc     mpc8xx         4fb3925     2014-04-18
 RPXlite_dw       powerpc     mpc8xx         0657e46e    2014-07-07
@@ -257,6 +308,7 @@ sbc2410x         arm         arm920t        1f7f0ed     2011-07-17
 sbc35_a9g20      arm         arm926ejs      f6b42c14    2015-05-13  Albin Tonnerre <albin.tonnerre@free-electrons.com>
 sbc405           powerpc     ppc4xx         -           -
 sc3              powerpc     ppc4xx         27e72156    2015-05-10  Heiko Schocher <hs@denx.de>
+scb9328          arm         arm920t        -           -
 SCM              powerpc     mpc8260        1b0757e     2012-10-28  Wolfgang Grandegger <wg@denx.de>
 scpu             arm         ixp            304db0b     2013-09-24  Stefan Roese <sr@denx.de>
 shannon          arm         sa1100         5df092d     2011-09-05  Rolf Offermanns <rof@sysgo.de>
@@ -267,10 +319,12 @@ smdk2400         arm         arm920t        ad218a8     2011-07-17  Gary Jennejo
 smdk6400         arm         arm1176        52587f1     2013-04-12  Zhong Hongbo <bocui107@gmail.com>
 smmaco4          powerpc     MPC5200        9ddc3af     2010-09-19
 SMN42            arm         arm720t        6aac646     2011-09-05
+snowball         arm         armv7          -           -
 sorcery          powerpc     mpc8220        d6ed322     2013-05-11
 spc1920          powerpc     mpc8xx         98ad54be    2014-07-07
 SPD823TS         powerpc     mpc8xx         72ba368f    2015-01-05  Wolfgang Denk <wd@denx.de>
 spieval          powerpc     MPC5200        69434e4     2010-09-19
+stamp9g20        arm         arm926ejs      -           -
 stxgp3           powerpc     mpc85xx        -           -           Dan Malek <dan@embeddedalley.com>
 stxssa           powerpc     mpc85xx        -           -           Dan Malek <dan@embeddedalley.com>
 stxxtc           powerpc     mpc8xx         0ace4d9d    2014-08-22  Dan Malek <dan@embeddedalley.com>
@@ -281,6 +335,9 @@ T4240EMU         powerpc     mpc85xx        7fc63cca    2015-05-05  York Sun <yo
 TASREG           m68k        mcf52x2        cbdc662a    2015-01-13  Matthias Fuchs <matthias.fuchs@esd.eu>
 tb0229           mips        mips32         3f3110d     2011-12-12
 TB5200           powerpc     mpc5xxx        470ee8b1    2015-03-17
+ti814x_evm       arm         armv7          -           -
+ti816x_evm       arm         armv7          -           -
+tk71             arm         arm926ejs      -           -
 TK885D           powerpc     mpc8xx         5d2a5ef7    2015-01-05
 tnetv107x        arm         arm1176        50b82c4b    2015-02-24  Chan-Taek Park <c-park@ti.com>
 tny_a9260        arm         arm926ejs      f6b42c14    2015-05-13  Albin Tonnerre <albin.tonnerre@free-electrons.com>
@@ -292,24 +349,40 @@ TQM8260          powerpc     mpc8260        ccc1950     2014-10-27  Wolfgang Den
 TQM8272          powerpc     mpc8260        f06f9a1     2014-10-27  Wolfgang Denk <wd@denx.de>
 TQM85xx          powerpc     MPC85xx        d923a5d     2012-10-04  Stefan Roese <sr@denx.de>
 trab             arm         S3C2400        566e5cf     2011-05-01  Gary Jennejohn <garyj@denx.de>
+trizepsiv        arm         pxa            -           -
+tt01             arm         arm1136        -           -
+tx25             arm         arm926ejs      -           -
+u8500_href       arm         armv7          -           -
 uc100            powerpc     mpc8xx         ceaf499b    2015-01-05  Stefan Roese <sr@denx.de>
 uc101            powerpc     mpc5xxx        ceaf499b    2015-01-05  Heiko Schocher <hs@denx.de>
 utx8245          powerpc     mpc824x        d622ac39    2015-01-05  Greg Allen <gallen@arlut.utexas.edu>
 v37              powerpc     mpc8xx         b8c1438a    2014-07-07
+versatileab      arm         arm926ejs      -           -
+versatilepb      arm         arm926ejs      -           -
+versatileqemu    arm         arm926ejs      -           -
 virtlab2         powerpc     mpc8xx         5d2a5ef7    2015-01-05  Wolfgang Denk <wd@denx.de>
+vision2          arm         armv7          -           -
+vl_ma2sc         arm         arm926ejs      -           -
+vl_ma2sc_ram     arm         arm926ejs      -           -
 VOH405           ppc4xx      405ep          807db88b    2015-01-13  Matthias Fuchs <matthias.fuchs@esd.eu>
 voiceblue        arm         arm925t        1b793a4     2011-07-17
 VoVPN-GW_100MHz  powerpc     MPC8260        26fe3d2     2010-10-24  Juergen Selent <j.selent@elmeg.de>
 VoVPN-GW         powerpc     mpc8260        cc90905f    2015-01-05
+vpac270_nor_128  arm         pxa            -           -
+vpac270_nor_256  arm         pxa            -           -
+vpac270_ond_256  arm         pxa            -           -
 W7OLMC           powerpc     ppc4xx         6beecd5d    2015-03-17  Erik Theisen <etheisen@mindspring.com>
 W7OLMG           powerpc     ppc4xx         6beecd5d    2015-03-17  Erik Theisen <etheisen@mindspring.com>
 wepep250         ARM         PXA2xx         7369478     2010-10-20  Peter Figuli <peposh@etc.sk>
+wireless_space   arm         arm926ejs      -           -
 WUH405           ppc4xx      405ep          fc88a5bf    2015-01-13  Matthias Fuchs <matthias.fuchs@esd.eu>
+xaeniax          arm         pxa            -           -
 xm250            arm         pxa            c477d72     2011-11-25
 xsengine         ARM         PXA2xx         4262a7c     2010-10-20
 XUPV2P           microblaze  -              8fab49e     2008-12-10  Michal Simek <monstr@monstr.eu>
 Yukon8220        powerpc     mpc8220        d6ed322     2013-05-11
 zeus             powerpc     ppc4xx         -           -           Stefan Roese <sr@denx.de>
+zipitz2          arm         pxa            -           -
 zpc1900          powerpc     mpc8260        6f80bb48    2014-05-30  Yuli Barcohen <yuli@arabellasw.com>
 ZUMA             powerpc     74xx_7xx       d928664f    2015-01-16  Nye Liu <nyet@zumanetworks.com>
 zylonite         arm         pxa            b66521a     2011-09-05